4 USAGE='<fetch-options> <repository> <refspec>...'
7 set_reflog_action "fetch $*"
8 cd_to_toplevel ;# probably unnecessary...
11 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
12 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
27 while case "$#" in 0) break ;; esac
30 -a|--a|--ap|--app|--appe|--appen|--append)
33 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
34 --upload-pa|--upload-pac|--upload-pack)
36 exec="--upload-pack=$1"
38 --upl=*|--uplo=*|--uploa=*|--upload=*|\
39 --upload-=*|--upload-p=*|--upload-pa=*|--upload-pac=*|--upload-pack=*)
40 exec=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)')
43 -f|--f|--fo|--for|--forc|--force)
46 -t|--t|--ta|--tag|--tags)
49 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
52 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
53 --update-he|--update-hea|--update-head|--update-head-|\
54 --update-head-o|--update-head-ok)
60 -k|--k|--ke|--kee|--keep)
64 shallow_depth="--depth=`expr "z$1" : 'z-[^=]*=\(.*\)'`"
68 shallow_depth="--depth=$1"
82 origin=$(get_default_remote)
83 test -n "$(get_remote_url ${origin})" ||
84 die "Where do you want to fetch from today?"
85 set x $origin ; shift ;;
90 # No command line override and we have configuration for the remote.
91 exec="--upload-pack=$(get_uploadpack $1)"
95 remote=$(get_remote_url "$@")
98 rsync_slurped_objects=
100 if test "" = "$append"
102 : >"$GIT_DIR/FETCH_HEAD"
105 # Global that is reused later
106 ls_remote_result=$(git ls-remote $exec "$remote") ||
107 die "Cannot get the repository state from $remote"
109 append_fetch_head () {
111 test -n "$verbose" && flags="$flags -v"
112 test -n "$force" && flags="$flags -f"
113 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION" \
114 git-fetch--tool append-fetch-head $flags "$@"
117 update_local_ref () {
119 test -n "$verbose" && flags="$flags -v"
120 test -n "$force" && flags="$flags -f"
121 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION" \
122 git-fetch--tool update-local-ref $flags "$@"
125 # updating the current HEAD with git-fetch in a bare
126 # repository is always fine.
127 if test -z "$update_head_ok" && test $(is_bare_repository) = false
129 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
132 # If --tags (and later --heads or --all) is specified, then we are
133 # not talking about defaults stored in Pull: line of remotes or
134 # branches file, and just fetch those and refspecs explicitly given.
135 # Otherwise we do what we always did.
137 reflist=$(get_remote_refs_for_fetch "$@")
141 echo "$ls_remote_result" |
142 git-show-ref --exclude-existing=refs/tags/ |
145 echo ".${name}:${name}"
149 # remote URL plus explicit refspecs; we need to merge them.
150 reflist="$reflist$LF$taglist"
152 # No explicit refspecs; fetch tags only.
166 # These are relative path from $GIT_DIR, typically starting at refs/
168 if expr "z$ref" : 'z\.' >/dev/null
171 ref=$(expr "z$ref" : 'z\.\(.*\)')
175 if expr "z$ref" : 'z+' >/dev/null
178 ref=$(expr "z$ref" : 'z+\(.*\)')
182 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
183 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
185 rref="$rref$LF$remote_name"
188 ( : subshell because we muck with IFS
191 git-fetch-pack --thin $exec $keep $shallow_depth "$remote" $rref ||
192 echo failed "$remote"
196 test -n "$verbose" && flags="$flags -v"
197 test -n "$force" && flags="$flags -f"
198 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION" \
199 git-fetch--tool native-store \
200 $flags "$remote" "$remote_nick" "$refs"
215 # These are relative path from $GIT_DIR, typically starting at refs/
217 if expr "z$ref" : 'z\.' >/dev/null
220 ref=$(expr "z$ref" : 'z\.\(.*\)')
224 if expr "z$ref" : 'z+' >/dev/null
227 ref=$(expr "z$ref" : 'z+\(.*\)')
231 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
232 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
234 rref="$rref$LF$remote_name"
236 # There are transports that can fetch only one head at a time...
238 http://* | https://* | ftp://*)
239 test -n "$shallow_depth" &&
240 die "shallow clone with http not supported"
241 proto=`expr "$remote" : '\([^:]*\):'`
242 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
245 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
246 "`git-config --bool http.noEPSV`" = true ]; then
247 noepsv_opt="--disable-epsv"
250 # Find $remote_name from ls-remote output.
253 echo "$ls_remote_result" |
256 test "z$name" = "z$remote_name" || continue
261 expr "z$head" : "z$_x40\$" >/dev/null ||
262 die "No such ref $remote_name at $remote"
263 echo >&2 "Fetching $remote_name from $remote using $proto"
264 git-http-fetch -v -a "$head" "$remote/" || exit
267 test -n "$shallow_depth" &&
268 die "shallow clone with rsync not supported"
269 TMP_HEAD="$GIT_DIR/TMP_HEAD"
270 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
271 head=$(git-rev-parse --verify TMP_HEAD)
273 test "$rsync_slurped_objects" || {
274 rsync -av --ignore-existing --exclude info \
275 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
277 # Look at objects/info/alternates for rsync -- http will
278 # support it natively and git native ones will do it on
279 # the remote end. Not having that file is not a crime.
280 rsync -q "$remote/objects/info/alternates" \
281 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
282 rm -f "$GIT_DIR/TMP_ALT"
283 if test -f "$GIT_DIR/TMP_ALT"
285 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
288 case "$alt" in 'bad alternate: '*) die "$alt";; esac
289 echo >&2 "Getting alternate: $alt"
290 rsync -av --ignore-existing --exclude info \
291 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
293 rm -f "$GIT_DIR/TMP_ALT"
295 rsync_slurped_objects=t
300 append_fetch_head "$head" "$remote" \
301 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge" || exit
309 http://* | https://* | ftp://* | rsync://* )
318 fetch_main "$reflist" || exit
320 # automated tag following
321 case "$no_tags$tags" in
325 # effective only when we are following remote branch
326 # using local tracking branch.
328 echo "$ls_remote_result" |
329 git-show-ref --exclude-existing=refs/tags/ |
332 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
333 echo >&2 "Auto-following $name"
334 echo ".${name}:${name}"
340 # do not deepen a shallow tree when following tags
342 fetch_main "$taglist" || exit ;;
346 # If the original head was empty (i.e. no "master" yet), or
347 # if we were told not to worry, we do not have to check.
352 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
353 if test "$curr_head" != "$orig_head"
356 -m "$GIT_REFLOG_ACTION: Undoing incorrectly fetched HEAD." \
358 die "Cannot fetch into the current branch."